#include <Application.h>
#include <Query.h>
#include <Volume.h>
#include <VolumeRoster.h>
#include <Message.h>
#include <NodeMonitor.h>
#include <Beep.h>
#include <InterfaceDefs.h>

#include <cstdlib>
#include <cstring>

#include <cstdio>

class ml : public BApplication
{
	public:
		ml() : BApplication("application/x-vnd.dippler.mail-lights")
		{
			new_messages = 0;
			SetPulseRate(2000000);
		}
		
		void ReadyToRun()
		{
			BVolume boot;
			query = new BQuery;
		
			BVolumeRoster().GetBootVolume(&boot);
			query->SetTarget(this);
			query->SetVolume(&boot);
			query->PushAttr("MAIL:status");
			query->PushString("New");
			query->PushOp(B_EQ);
			query->PushAttr("BEOS:TYPE");
			query->PushString("text/x-email");
			query->PushOp(B_EQ);
			query->PushOp(B_AND);
			query->Fetch();
			
			BEntry entry;
			for (new_messages = 0; query->GetNextEntry(&entry) == B_OK; new_messages++);
		}
		
		void Pulse()
		{
			int numblinks = new_messages;
			if(numblinks>10)
			{
				numblinks = 5;
			}
			for(int i = 0; i < numblinks; i++)
			{
				uint32 oldlocks = modifiers()&(B_CAPS_LOCK|B_NUM_LOCK);
				set_keyboard_locks(oldlocks|B_SCROLL_LOCK);
				snooze(1000000/numblinks);
				set_keyboard_locks(oldlocks);
				snooze(500000/numblinks);
			}
		}
		
		void MessageReceived(BMessage* msg)
		{
			if(msg->what==B_QUERY_UPDATE)
			{
				int32 opcode = 0;
				msg->FindInt32("opcode",&opcode);
				if(opcode==B_ENTRY_CREATED)
				{
					new_messages++;
				}
				if(opcode==B_ENTRY_REMOVED)
				{
					new_messages--;
				}
			} else
			{
				BApplication::MessageReceived(msg);
			}
		}
		
		~ml()
		{
			query->Clear();
			delete query;
		}
	private:
		BQuery* query;
		int new_messages;
};

int main()
{
	new ml();
	be_app->Run();
	delete be_app;
	return 0;
}